#ifndef CHARACTER_H
#define CHARACTER_H

#include "util.h"

typedef struct player_character {
  // No special data for PC right now
} pc_t;

typedef struct monster {
  uint32_t characteristics;
} monster_t;

typedef struct character {
  pc_t *player;
  monster_t *monster;
  position_t pos;
  int speed;
  int seq_num;
  int next_turn;
} character_t;
/*
static int32_t character_turn_cmp(const void *key, const void *with) {
  if (((character_t *) key)->next_turn == ((character_t *) with)->next_turn) {
    return ((character_t *) key)->seq_num - ((character_t *) with)->seq_num;
  } else {
    return ((character_t *) key)->next_turn - ((character_t *) with)->next_turn;
  }
}*/

#endif
